diff --git a/tests/modeltests/fixtures_model_package/models/__init__.py b/tests/modeltests/fixtures_model_package/models/__init__.py
index 1581102..c0450b2 100644
--- a/tests/modeltests/fixtures_model_package/models/__init__.py
+++ b/tests/modeltests/fixtures_model_package/models/__init__.py
@@ -12,43 +12,3 @@ class Article(models.Model):
         app_label = 'fixtures_model_package'
         ordering = ('-pub_date', 'headline')
 
-__test__ = {'API_TESTS': """
->>> from django.core import management
->>> from django.db.models import get_app
-
-# Reset the database representation of this app.
-# This will return the database to a clean initial state.
->>> management.call_command('flush', verbosity=0, interactive=False)
-
-# Syncdb introduces 1 initial data object from initial_data.json.
->>> Article.objects.all()
-[<Article: Python program becomes self aware>]
-
-# Load fixture 1. Single JSON file, with two objects.
->>> management.call_command('loaddata', 'fixture1.json', verbosity=0)
->>> Article.objects.all()
-[<Article: Time to reform copyright>, <Article: Poker has no place on ESPN>, <Article: Python program becomes self aware>]
-
-# Load fixture 2. JSON file imported by default. Overwrites some existing objects
->>> management.call_command('loaddata', 'fixture2.json', verbosity=0)
->>> Article.objects.all()
-[<Article: Django conquers world!>, <Article: Copyright is fine the way it is>, <Article: Poker has no place on ESPN>, <Article: Python program becomes self aware>]
-
-# Load a fixture that doesn't exist
->>> management.call_command('loaddata', 'unknown.json', verbosity=0)
-
-# object list is unaffected
->>> Article.objects.all()
-[<Article: Django conquers world!>, <Article: Copyright is fine the way it is>, <Article: Poker has no place on ESPN>, <Article: Python program becomes self aware>]
-"""}
-
-
-from django.test import TestCase
-
-class SampleTestCase(TestCase):
-    fixtures = ['fixture1.json', 'fixture2.json']
-
-    def testClassFixtures(self):
-        "Check that test case has installed 4 fixture objects"
-        self.assertEqual(Article.objects.count(), 4)
-        self.assertEquals(str(Article.objects.all()), "[<Article: Django conquers world!>, <Article: Copyright is fine the way it is>, <Article: Poker has no place on ESPN>, <Article: Python program becomes self aware>]")
diff --git a/tests/modeltests/fixtures_model_package/tests.py b/tests/modeltests/fixtures_model_package/tests.py
new file mode 100644
index 0000000..0738dbd
--- /dev/null
+++ b/tests/modeltests/fixtures_model_package/tests.py
@@ -0,0 +1,69 @@
+from django.core import management
+from django.test import TestCase
+
+from models import Article
+
+
+class SampleTestCase(TestCase):
+    fixtures = ['fixture1.json', 'fixture2.json']
+
+    def testClassFixtures(self):
+        "Check that test case has installed 4 fixture objects"
+        self.assertEqual(Article.objects.count(), 4)
+        self.assertQuerysetEqual(
+            Article.objects.all(),[
+                "Django conquers world!",
+                "Copyright is fine the way it is",
+                "Poker has no place on ESPN",
+                "Python program becomes self aware"
+            ],
+            lambda a: a.headline
+        )
+
+
+class FixtureTestCase(TestCase):
+    def test_initial_data(self):
+        # Syncdb introduces 1 initial data object from initial_data.json.
+        self.assertQuerysetEqual(
+            Article.objects.all(), [
+                "Python program becomes self aware"
+            ],
+            lambda a: a.headline
+        )
+    
+    def test_loaddata(self):
+        # Load fixture 1. Single JSON file, with two objects.
+        management.call_command("loaddata", "fixture1.json", verbosity=0)
+        self.assertQuerysetEqual(
+            Article.objects.all(), [
+                "Time to reform copyright",
+                "Poker has no place on ESPN",
+                "Python program becomes self aware",
+            ],
+            lambda a: a.headline,
+        )
+        
+        # Load fixture 2. JSON file imported by default. Overwrites some
+        # existing objects
+        management.call_command("loaddata", "fixture2.json", verbosity=0)
+        self.assertQuerysetEqual(
+            Article.objects.all(), [
+                "Django conquers world!",
+                "Copyright is fine the way it is",
+                "Poker has no place on ESPN",
+                "Python program becomes self aware",
+            ],
+            lambda a: a.headline,
+        )
+
+        # Load a fixture that doesn't exist
+        management.call_command("loaddata", "unknown.json", verbosity=0)
+        self.assertQuerysetEqual(
+            Article.objects.all(), [
+                "Django conquers world!",
+                "Copyright is fine the way it is",
+                "Poker has no place on ESPN",
+                "Python program becomes self aware",
+            ],
+            lambda a: a.headline,
+        )